//}eANX
import java.awt.*;
import java.util.*;

public class Material
{
	protected double ka;	//W
	protected double kd;	//gUˌW
	protected double ks;	//ʔˌW
	protected double n;		//PhongW
	protected Color color;	//F
	
	final static int NUM_DATA = 7;
	
	//RXgN^
	public Material()
	{
		ka = 0;
		kd = 0;
		ks = 0;
		n  = 0;
		color = new Color(0, 0, 0);
	}
	
	//lwRXgN^
	public Material(double ka, double kd, double ks,
					double n, Color col)
	{
		this.ka = ka;
		this.kd = kd;
		this.ks = ks;
		this.n  = n;
		this.color = col;
	}
	
	//f[^ꂽŏ
	//}eAf[^tH[}bg:r g b ka kd ks n
	public Material(String data)
	{
		int r, g, b;
	
		try
		{
			//}eAf[^tH[}bg(ka kd ks n color-r g b)
			StringTokenizer s = new StringTokenizer(data, " ");		//Xy[XƂɕ񕪊
			if (s.countTokens() >= NUM_DATA){						//͂ꂽKvȏȂǂݍ
				r = Integer.parseInt(s.nextToken());
				g = Integer.parseInt(s.nextToken());
				b = Integer.parseInt(s.nextToken());
				
				color = new Color(r, g, b);
				
				ka = Double.parseDouble(s.nextToken());
				kd = Double.parseDouble(s.nextToken());
				ks = Double.parseDouble(s.nextToken());
				n  = Double.parseDouble(s.nextToken());
			}
			else
				throw new IllegalArgumentException("[Material]͒ľ܂:"+data);
		}
		catch(IllegalArgumentException e)
		{
			throw e;
		}
	}
	
	//x
	public double getKa()
	{
		return ka;
	}
	
	//gUx
	public double getKd()
	{
		return kd;
	}
	
	//ʔˌx
	public double getKs()
	{
		return ks;
	}
	
	//PhongW
	public double getN()
	{
		return n;
	}
	
	//F
	public Color getColor()
	{
		return color;
	}
}