//SetPixel@\EChENX
import java.io.*;
import java.awt.*;
import java.awt.image.*;
import java.lang.*;
import java.util.*;
import javax.swing.*;

public class PaintFrame extends JFrame
{
	static final int W_WIDTH = 256;		//`̈TCYi摜w莞j
	static final int W_HEIGHT = 256;

	protected Image offscreen;		//ItXN[
	protected Image srcimg;			//摜
	protected int sw, sh;			//XN[i摜jTCY
	protected Insets in;			//]
	protected String filename;			
	
	protected int[] spixels;		//摜sNZ
	
	//Cӂ̕`揈
	public void paintScreen()
	{
		
	}
	
	//RXgN^i󔒃EChEj
	public PaintFrame()
	{
		sw = W_WIDTH;
		sh = W_HEIGHT;
		
		spixels = new int[sw * sh];	
		
		this.setVisible(true);
	}
	
	public PaintFrame(int w, int h)
	{
		sw = w;
		sh = h;
		
		spixels = new int[sw * sh];	
		
		this.setVisible(true);
	}
	
	//RXgN^i摜wj
	public PaintFrame(String filepath)
	{
		filename = filepath;
		
		File SrcFile = new File(filepath);
		if(!SrcFile.canRead())
		{
			System.out.println("w肳ꂽt@Cǂݍ߂܂");
			System.exit(1);
		}
		
		srcimg = Toolkit.getDefaultToolkit().getImage(filename); 				//摜ǂݍ
		
		MediaTracker mt = new MediaTracker(this);							//ǂݍ܂܂őҋ@
		mt.addImage(srcimg, 0);
		try 
		{
			mt.waitForID(0);
		} 
		catch(InterruptedException ex) {}
		
		sw = srcimg.getWidth(this);											//摜TCY擾
		sh = srcimg.getHeight(this);
		
		spixels = new int[sw * sh];												//摜TCỸm
		
		PixelGrabber pg = new PixelGrabber(srcimg, 0, 0, sw, sh, spixels, 0, sw);	//摜̃sNZ̐Fǂݍ
		try
		{
			pg.grabPixels();
		}
		catch(InterruptedException e){}
		
		
		this.setVisible(true);
	}
	
	//RXgN^ł̓ItXN[𐶐łȂaddNotifyŕ`s
	public void addNotify()
	{
		super.addNotify();													//X[p[NXaddNotifys

		in = getInsets();														//]̃TCY擾				
		
		setBounds(10, 10, sw + in.left + in.right, sh + in.top + in.bottom);		//EChE]lTCYɍĐݒ

		offscreen = createImage(sw, sh);										//ItXN[		
	}

	//ĕ`揈
	public void paint(Graphics g)
	{
		g.drawImage(offscreen, in.left, in.top, this);							//ItXN[EChEɕ`
	}
	
	//w肳ꂽW̃sNZw肳ꂽFœhԂ
	public void setPixel(int x, int y, Color col)
	{
		Graphics og=offscreen.getGraphics();
		Graphics wg=this.getGraphics();
		
		og.setColor(col);
		wg.setColor(col);
		
		og.fillRect(x, y, 1, 1);						//ItXN[֏
		wg.fillRect(in.left + x, in.top + y, 1, 1);		//EChE֏
	}
	
	//ǂ݂܂ꂽ摜̃sNZ擾
	public Color getImagePixel(int x, int y)
	{
		int r, g, b;
		
		r = (spixels[y * sw + x] & 0x00ff0000) >> 16;//lRGBɕ
		g = (spixels[y * sw + x] & 0x0000ff00) >> 8;
		b = (spixels[y * sw + x] & 0x000000ff);
		
		Color col = new Color(r, g, b);
		return col;
	}
	
	//w肳ꂽFŕ`挋ʂNA
	public void clearScreen(Color srccol)
	{
		Graphics og=offscreen.getGraphics();
		Graphics wg=this.getGraphics();
		
		og.setColor(srccol);
		wg.setColor(srccol);
		
		og.fillRect(0, 0, sw, sh);
		wg.fillRect(0, 0, sw + in.left + in.right, sh + in.top + in.bottom);
	}
	
	//L[{[h1sǂݍ݁AStringƂĕԂ
	public String inputLine()
	{
		String str = "";
		
		BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
		try
		{
			str = in.readLine();
		}
		catch(IOException e)
		{
			System.out.println("Error" + e);
			System.exit(0);
		}
		return(str);
	}
	
	public int getScreenWidth()
	{
		return sw;
	}
	
	public int getScreenHeight()
	{
		return sh;
	}
}
